class Patient:
    """Beschreibung der Klasse Patient"""
    
    def __init__(self, name):
        """Konstruktor des Patienten"""
        self.name = name
        self.nachfolger = None

    def NachfolgerSetzen(self, nf):
        """Nachfolger des Patienten setzen"""
        self.nachfolger = nf

    def NachfolgerGeben(self):
        """Gibt den Nachfolger des Patienten aus"""
        return self.nachfolger

    def InformationAusgeben(self):
        """Gibt Information über den Patienten aus"""
        print(self.name)

    def NameGeben(self):
        """Gibt den Namen des Patienten aus"""
        return self.name


class Warteschlange:
    """Beschreibung der Warteschlange"""
    def __init__(self): 
        """Konstruktor der Warteschlange"""
        self.anfang = None
        self.ende = None

    def Einfügen(self, patient_neu):
        """Fügt einen neuen Patienten am Ende der Warteschlange ein"""
        if self.anfang is None:
            self.anfang = patient_neu
        else:
            self.ende.NachfolgerSetzen(patient_neu)
        self.ende = patient_neu

    def Entfernen(self):
        """Entfernt den ersten Patient aus der Warteschlange und gibt ihn zurück"""
        p = self.anfang
        if self.anfang is not None:
            if self.anfang == self.ende:
                self.anfang = None
                self.ende = None
            else:
                self.anfang = self.anfang.NachfolgerGeben()
        return p

    def InformationAusgeben(self):
        """Gibt Information über die Warteschlange aus"""
        if self.anfang is not None:
            self.anfang.InformationAusgeben()
            
    def AnfangGeben(self):
        """Gibt den Anfang zurück"""
        return self.anfang


wartesch1 = Warteschlange()
patient1 = Patient("Andi")
patient2 = Patient("Berin")
patient3 = Patient("Carla")
patient4 = Patient("Didi")
patient5 = Patient("Emil")
patient6 = Patient("Franzi")
patient7 = Patient("Gabi")
patient8 = Patient("Hugo")
patient9 = Patient("Ida")
wartesch1.Einfügen(patient1)
wartesch1.Einfügen(patient2)
wartesch1.Einfügen(patient3)
wartesch1.Einfügen(patient4)
wartesch1.Einfügen(patient5)
wartesch1.Einfügen(patient6)
wartesch1.Einfügen(patient7)
wartesch1.Einfügen(patient8)
wartesch1.Einfügen(patient9)
element = wartesch1.AnfangGeben()
while not element is None:
    element.InformationAusgeben()
    element = element.NachfolgerGeben()